"use strict";

var _require = require('path'),
    resolve = _require.resolve;

var _require2 = require('fs'),
    readFileSync = _require2.readFileSync,
    existsSync = _require2.existsSync;

var _require3 = require('loader-utils'),
    stringifyRequest = _require3.stringifyRequest;

var pageLoaderPath = require.resolve('./page-loader');

module.exports = function appLoader(content) {
  var source = content;
  var configPath = this.resourcePath.replace(/app\.js$/, 'manifest.json');
  var loadPagesContent = '';

  if (existsSync(configPath)) {
    var config = JSON.parse(readFileSync(configPath, 'utf-8'));
    this.addDependency(configPath);
    var pages = Object.keys(config.pages || {});

    for (var i = 0, l = pages.length; i < l; i++) {
      var pageName = pages[i];
      var pagePath = resolve(this.rootContext, config.pages[pageName]);
      loadPagesContent += "require(".concat(stringifyRequest(this, pageLoaderPath + "?pageName=".concat(pageName, "!") + pagePath), ");");
    }
  }

  return source + loadPagesContent;
};